// QDownloadWidget.cpp: QDownloadWidget NX̃Cve[V
//
//////////////////////////////////////////////////////////////////////
#include "qover_win32.h"
#include "qoverdlg.h"
#include "qdownloadwidget.h"
#include "downloadthread.h"
#include "shareobj.h"
#include "urlobj.h"

//////////////////////////////////////////////////////////////////////
// \z/
//////////////////////////////////////////////////////////////////////
QDownloadWidget::QDownloadWidget( QWidget *parent, const char *name )
    : QWidget( parent, name )
{
	m_pThread=0;
	m_pwDownload=(QOverDlg*)parent;
    QVBoxLayout* pvbox = new QVBoxLayout(this, 2);
    QHBoxLayout* phbox = new QHBoxLayout(this, 2);

	m_plvUrl=new QListView(this);
	m_plvUrl->setSorting(-1,false);
	m_plvUrl->addColumn("V");
	m_plvUrl->addColumn("Title");
	m_plvUrl->addColumn("Time");
	m_plvUrl->addColumn("User");
	m_plvUrl->addColumn("ID");
	m_plvUrl->addColumn("Type");
	m_plvUrl->addColumn("Image");

    m_plvUrl->setAllColumnsShowFocus(true);
    m_plvUrl->setColumnWidth(1, 400);
    m_plvUrl->setColumnWidth(2, 100);
    m_plvUrl->setColumnWidth(3, 100);
    m_plvUrl->setColumnWidth(4, 100);
	pvbox->addWidget(m_plvUrl);

	m_pbClear	= new QPushButton("Clear(&J)",this);
	m_pbDel		= new QPushButton("Delete(&K)",this);
	m_pbDownload= new QPushButton("Download(&L)",this);
	m_pbClear->setAccel(CTRL+'J');
	m_pbDel->setAccel(CTRL+'K');
	m_pbDownload->setAccel(CTRL+'L');


	phbox->addWidget(m_pbClear);
	phbox->addWidget(m_pbDel);
	phbox->addWidget(m_pbDownload);
	pvbox->addLayout(phbox);

	{	// Cxg
		connect( m_pbClear     , SIGNAL( clicked() ), this, SLOT( onDeleteAll()   ) );
		connect( m_pbDel       , SIGNAL( clicked() ), this, SLOT( onDelete()   ) );
		connect( m_pbDownload  , SIGNAL( clicked() ), this, SLOT( onDownload()   ) );
	}
	m_pObj=0;
}

QDownloadWidget::~QDownloadWidget()
{

}

QListView* QDownloadWidget::ref_list()
{
	return m_plvUrl;
}

void QDownloadWidget::onDelete()
{
	if(m_pwDownload->isThread())
	{	// ȂXbhNĂꍇ삳Ȃ
		return;
	}

	QListViewItem* pitem0=0;
	for(QListViewItem* pitem = m_plvUrl->firstChild();pitem;pitem = pitem->nextSibling())
	{
		if (m_plvUrl->isSelected ( pitem ))
		{
			QListViewItem* pitem2=pitem->nextSibling();
			m_plvUrl->removeItem(pitem);
			if(pitem2)
			{
				m_plvUrl->setSelected(pitem2,true);
			}
			else if(pitem0)
			{
				m_plvUrl->setSelected(pitem0,true);			
			}
			return;
		}
		pitem0=pitem;
    }
}

void QDownloadWidget::onDeleteAll()
{
	if(m_pwDownload->isThread())
	{	// ȂXbhNĂꍇ삳Ȃ
		return;
	}
	m_plvUrl->clear();
}

void QDownloadWidget::onDownload()
{
	if(m_pThread)
	{
		m_pThread->cancel();
		return;
	}

	if(strlen(m_pObj->ref_Path())<=0)
	{
		return;
	}

	QOverDlg* pDlg=(QOverDlg*)m_pwDownload;
	pDlg->progress(0,"");
	m_pbDownload->setText("Cancel(&L)");
	m_pbDownload->setAccel(CTRL+'L');

	m_pThread = new downloadThread(m_plvUrl,m_pObj);
}

//! DownloadXg̓e𕜋AB
void QDownloadWidget::setObj(shareObj *pObj)
{
	m_pObj=pObj;

	QCString qcsTemp=m_pObj->ref_Path();	
	if(2>qcsTemp.length())
	{
		fputs("load path is too short.",stderr);
		return;
	}

	qcsTemp+="download.list";
	fprintf(stderr,"load %s\n",(const char*)qcsTemp);

	// QFile::readLinegƕ̂ŋ̍
	FILE* fp=fopen((const char*)qcsTemp,"r");
	if(!fp)
	{
		fputs("cannot open the file.",stderr);
		return;
	}

#define READ_BUFFER_SIZE	4096
	QByteArray buffer(READ_BUFFER_SIZE+4);
	char* pBuffer=buffer.data();

	while( 0<fgets(&pBuffer[3],READ_BUFFER_SIZE,fp))
	{
		char* p[8]={0,0,0,0,0,0,0,0};
		pBuffer[READ_BUFFER_SIZE]=0;
		p[0]=pBuffer;
	
		int nInsert=1;
		for(int n=1;n<8;n++)
		{
			p[n]=strstr(&p[n-1][3],"<\t>");
			if(p[n]==0)
			{
				nInsert=0;
				break;
			}
			p[n][0]='\0';		
		}
		if(nInsert)
		{
			m_plvUrl->insertItem(new QListViewItem( m_plvUrl,&p[0][3],QString::FROM_TR(&p[1][3]),QString::FROM_TR(&p[2][3]),QString::FROM_TR(&p[3][3]),QString::FROM_TR(&p[4][3]),QString::FROM_TR(&p[5][3]),QString::FROM_TR(&p[6][3]) ));
		}
	}
	fclose(fp);
}

//! Xbh̏I҂sB
int QDownloadWidget::timeUpdate(int* pnError)
{
	*pnError=0;
	if(!m_pThread)
	{
		return 0;
	}

	if(!m_pThread->status())
	{
		return m_pThread->current();
	}
	m_pwDownload->progress(100,"");

	*pnError=m_pThread->error();
	delete m_pThread;
	m_pThread=0;

	m_pbDownload->setText("Download(&L)");
	m_pbDownload->setAccel(CTRL+'L');

	fprintf(stderr,"download thread endcode=%d\n",*pnError);
	if(*pnError<0)
	{
		return -1;
	}
	return 0;
}

//! DownloadXg̓eۑAɗpB
void QDownloadWidget::save()
{
	QCString qcsTemp=m_pObj->ref_Path();	
	if(2>qcsTemp.length())
	{
		fputs("save path is too short.",stderr);
		return;
	}

	qcsTemp+="download.list";
	fprintf(stderr,"save %s\n",(const char*)qcsTemp);

	QFile file(QString::FROM_TR(qcsTemp));
	if(!file.open(IO_WriteOnly))
	{
		fputs("cannot open the file.",stderr);
		return;
	}

	for(QListViewItem* pitem = m_plvUrl->firstChild(); pitem; pitem=pitem->nextSibling())
	{
		for (int n=0;n<7;n++)
		{
			qcsTemp=pitem->text(n).CONVERT_TR();
			if (n==0 && qcsTemp[0]=='o')
			{
				break;
			}
			file.writeBlock(qcsTemp,qcsTemp.length());
			file.writeBlock("<\t>",3);
		}
		file.writeBlock("\r\n",2);
	}
}