// QSettingDlg.cpp: QSettingDlg NX̃Cve[V
//
//////////////////////////////////////////////////////////////////////

#include "qover_win32.h"
#include "qsettingdlg.h"

#include "shareobj.h"
#include "cfgreader.h"
#include <stdlib.h>
#include <stdlib.h>
//////////////////////////////////////////////////////////////////////
// \z/
//////////////////////////////////////////////////////////////////////

QSettingDlg::QSettingDlg( QWidget *parent, const char *name, WFlags f  )
:    QDialog(parent,name,TRUE,f)
{
	QVBoxLayout* pvbox  = new QVBoxLayout(this, 5);
	QHBoxLayout* phbox0 = new QHBoxLayout(this, 5);
	QHBoxLayout* phbox1 = new QHBoxLayout(this, 5);
	QHBoxLayout* phbox2 = new QHBoxLayout(this, 5);
	QHBoxLayout* phbox3 = new QHBoxLayout(this, 5);
	QHBoxLayout* phbox4 = new QHBoxLayout(this, 5);
	QHBoxLayout* phbox5 = new QHBoxLayout(this, 2);
	QHBoxLayout* phbox6 = new QHBoxLayout(this, 4);

	{
		QLabel* plWork		= new QLabel("workdir:",this);
		plWork->setMinimumWidth(60);
		QLineEdit* pleWork	= new QLineEdit(this);
		phbox0->addWidget(plWork);
		phbox0->addWidget(pleWork);
		pvbox->addLayout(phbox0);
		pleWork->setMaxLength(255);
		m_pleWork	=pleWork;
	}

	{
		QLabel* plProxy		= new QLabel("proxy:",this);
		plProxy->setMinimumWidth(60);
		QLineEdit* pleProxy	= new QLineEdit(this);
		phbox1->addWidget(plProxy);
		phbox1->addWidget(pleProxy);

		QLabel* plPort		= new QLabel("port:",this);
		QLineEdit* plePort	= new QLineEdit(this);
		plePort->setMaximumWidth(60);
		phbox1->addWidget(plPort);
		phbox1->addWidget(plePort);
		pvbox->addLayout(phbox1);

		pleProxy->setMaxLength(127);
		plePort->setMaxLength(6);
		m_pleProxy	=pleProxy;
		m_plePort	=plePort;
	}

	{
		QLabel* plUser		= new QLabel("userID:",this);
		plUser->setMinimumWidth(60);
		QLineEdit* pleUser	= new QLineEdit(this);
		phbox2->addWidget(plUser);
		phbox2->addWidget(pleUser);

		QLabel* plPass =	new QLabel("pass:",this);
		QLineEdit* plePass	= new QLineEdit(this);
		plePass->setMaximumWidth(60);
		phbox2->addWidget(plPass);
		phbox2->addWidget(plePass);
		pvbox->addLayout(phbox2);

		pleUser->setMaxLength(30);
		plePass->setMaxLength(30);
		m_pleUser	=pleUser;
		m_plePass	=plePass;
	}

	{
		QLabel* plUA		= new QLabel("User-Agent:",this);
		QComboBox* pcbUA	= new QComboBox(this);
		pcbUA->insertItem("q-over",-1);
		pcbUA->insertItem("Netfront",-1);
		pcbUA->insertItem("Opera",-1);
		pcbUA->insertItem("IE6",-1);
		pcbUA->insertItem("IE7",-1);
		pcbUA->insertItem("Firefox",-1);
		phbox3->addWidget(plUA);
		phbox3->addWidget(pcbUA);
		pvbox->addLayout(phbox3);

		m_pcbUA		=pcbUA;
	}

	{
		QLabel* plTimeout		= new QLabel("time out:",this);
		QComboBox* pcbTimeout	= new QComboBox(this);
		pcbTimeout->insertItem("15",-1);
		pcbTimeout->insertItem("30",-1);
		pcbTimeout->insertItem("45",-1);
		pcbTimeout->insertItem("60",-1);
		pcbTimeout->insertItem("120",-1);
		phbox4->addWidget(plTimeout);
		phbox4->addWidget(pcbTimeout);

		QLabel* plView		= new QLabel("html view:",this);
		QComboBox* pcbView	= new QComboBox(this);
		pcbView->insertItem("no",-1);
		pcbView->insertItem("yes",-1);
		phbox4->addWidget(plView);
		phbox4->addWidget(pcbView);
		pvbox->addLayout(phbox4);

		m_pcbTimeout=pcbTimeout;
		m_pcbView	=pcbView;
	}

	{
		QLabel* plCache		= new QLabel("cache:",this);
		QComboBox* pcbCache	= new QComboBox(this);
		pcbCache->insertItem("384",-1);
		pcbCache->insertItem("1024",-1);
		pcbCache->insertItem("2048",-1);
		pcbCache->insertItem("3072",-1);
		pcbCache->insertItem("4096",-1);
		phbox5->addWidget(plCache);
		phbox5->addWidget(pcbCache);

		QLabel* plMode		= new QLabel("play mode:",this);
		QComboBox* pcbMode	= new QComboBox(this);
		pcbMode->insertItem("not use",-1);
		pcbMode->insertItem("hardware",-1);
		pcbMode->insertItem("software",-1);
		phbox5->addWidget(plMode);
		phbox5->addWidget(pcbMode);
		
		pvbox->addLayout(phbox5);

		m_pcbCache	=pcbCache;
		m_pcbMode	=pcbMode;
	}

	{
		QPushButton* pbApply= new QPushButton("&Apply",this);
		QPushButton* pbUndo = new QPushButton("&Undo",this);
		pbApply->setAccel(CTRL+'A');
		pbUndo->setAccel(CTRL+'U');

		phbox6->addWidget(pbApply);
		phbox6->addWidget(pbUndo);
		pvbox->addLayout(phbox6);	

		connect( pbApply, SIGNAL( clicked() ), this, SLOT( apply() ) );
		connect( pbUndo, SIGNAL( clicked() ), this, SLOT( undo() ) );
	}

	m_pObj=0;
}

QSettingDlg::~QSettingDlg()
{

}

void QSettingDlg::setObj(shareObj *pObj)
{
	m_pObj=pObj;
	undo();
}

void QSettingDlg::apply()
{

	m_pObj->Cache(m_pcbCache->currentItem());
	m_pObj->Image(m_pcbView->currentItem());
	m_pObj->Play(m_pcbMode->currentItem());
	m_pObj->Timeout(m_pcbTimeout->currentItem());
	m_pObj->UA(m_pcbUA->currentItem());
	m_pObj->Port(atoi((const char*)m_plePort->text()));

	QCString st=m_pleWork->text().CONVERT_TR();
#ifdef WIN32
	if(st.at(st.length()-1)!='\\')
	{	// win32 ł͂ƓȂǁ@܂
		st+="\\";
	}
#else
	if(st.length()<=1)
	{
		st="/home/zaurus/Documents/Movie_Files/";
	}
	if(st.at(st.length()-1)!='/')
	{	
		st+="/";
	}
#endif
	m_pObj->Path (st);
	m_pleWork->setText (QString::FROM_TR(m_pObj->ref_Path()));	
	m_pObj->Proxy(m_pleProxy->text().CONVERT_TR());
	m_pObj->Name (m_pleUser->text().CONVERT_TR());
	m_pObj->Pass (m_plePass->text().CONVERT_TR());

	m_pObj->write(1);
}

void QSettingDlg::undo()
{
	m_pcbCache->setCurrentItem(m_pObj->ref_Cache());
	m_pcbView->setCurrentItem(m_pObj->ref_Image());
	m_pcbMode->setCurrentItem(m_pObj->ref_Play());
	m_pcbTimeout->setCurrentItem(m_pObj->ref_Timeout());
	m_pcbUA->setCurrentItem(m_pObj->ref_UA());

	char str[30]={"0"};
    sprintf(str,"%d",m_pObj->ref_Port());
	m_plePort->setText(str);	

	m_pleWork->setText (QString::FROM_TR(m_pObj->ref_Path()));	
	m_pleProxy->setText(QString::FROM_TR(m_pObj->ref_Proxy()));
	m_pleUser->setText (QString::FROM_TR(m_pObj->ref_Name()));
	m_plePass->setText (QString::FROM_TR(m_pObj->ref_Pass()));	

	m_pObj->write(0);
}